import { Component } from "../..";
export class Item extends Component {
    constructor() {
        super(...arguments);
        this.location = null;
        this.marginLeft = 0;
        this.marginRight = 0;
        this.width = 0;
    }
    init() {
        /**
         * Needed because otherwise, Safari doesn't bubble up touch events on iOS
         * @see https://stackoverflow.com/a/41287408/3130281
         */
        this.$element.addEventListener("touchstart", () => { });
    }
    update() {
        let style = window.getComputedStyle(this.$element);
        let paddingLeft = parseFloat(style.paddingLeft);
        let paddingRight = parseFloat(style.paddingRight);
        this.marginLeft = parseFloat(style.marginLeft) + paddingLeft;
        this.marginRight = parseFloat(style.marginRight) + paddingRight;
        this.width = parseFloat(style.width);
        if (style.boxSizing === "border-box") {
            this.width -= paddingLeft + paddingRight;
        }
    }
    space() {
        return this.marginLeft + this.width + this.marginRight;
    }
}
