import { Emitter } from "../../utils/emitter";
import { Gesture, Swipe } from "../../utils/gesture";
import { Component } from "../..";
import { Item } from "./item";
import { Screen } from "./screen";
interface Options {
    clickThreshold: number;
    overdrag: number;
    infinite: boolean;
    itemsPerScreen?: number;
    orderContainer?: HTMLElement;
    screenOffset?: number;
    screenCentering?: boolean;
    screenChangeSpeed?: number;
}
declare type Events = {
    slideChange: (slide: number, screen: Screen) => void;
};
export declare class Rail extends Component<HTMLElement, Options> {
    ["constructor"]: typeof Rail;
    static Screen: typeof Screen;
    static components: {
        item: typeof Item;
    };
    static defaults: Options;
    $emitter: Emitter<Events>;
    $item: Item[];
    isDrag: boolean;
    isDragging: boolean;
    isDraggingLink: boolean;
    gesture: Gesture;
    swipe: Swipe;
    screens: Screen[];
    activeScreen: Screen;
    width: number;
    offset: number;
    offsetRender: number;
    offsetLogical: number;
    direction: number;
    order: Item[];
    orderIndex: number;
    orderContainer: HTMLElement;
    clickHandler: (event: Event) => void;
    resizeHandler: () => void;
    renderHandler: () => void;
    create(): void;
    init(): void;
    destroy(): void;
    handleClick(event: Event): void;
    handleResize(): void;
    updateLayout(): void;
    getWidth(): number;
    getScreenGroups(): Item[][];
    getScreens(groups: Item[][]): {
        items: Item[];
        offset: number;
    }[];
    pointerDown(event: any): void;
    pointerUp(): void;
    getClosestScreen(offset: number): Screen;
    getSmallestDelta(offset: number, point: number): number;
    getScreenAnchor(screen: Screen): number;
    nextScreen(): void;
    prevScreen(): void;
    getScreenByOffset(offset: number): Screen;
    setScreen(screen: Screen): void;
    update(): void;
    updateOffsetRender(): void;
    getConstrainedOffset(offset: number): number;
    getOverdrag(amount: number): number;
    render(): void;
    updateOffsetLogical(): void;
    renderOffsetLogical(): void;
    updateOrder(): void;
}
export default Rail;
