import { Component } from "../..";
import { mutate } from "../../core/mutate";
export class Content extends Component {
    init() {
        this.wrapper = this.$element.firstElementChild;
    }
}
export class Expandable extends Component {
    init() {
        this.wrapper = this.$element.firstElementChild;
        this.update();
        this.listen();
    }
    update() {
        let fullHeight = this.wrapper.offsetHeight;
        let expandedHeight = this.$content.$element.offsetHeight;
        let fluidHeight = this.$content.wrapper.offsetHeight;
        let fixedHeight = fullHeight - expandedHeight;
        mutate(() => {
            this.$element.style.setProperty("--fluid-height", `${fluidHeight}px`);
            this.$element.style.setProperty("--fixed-height", `${fixedHeight}px`);
        });
    }
    listen() {
        window.addEventListener("resize", () => {
            this.update();
        });
    }
}
Expandable.components = {
    content: Content,
};
export default Expandable;
