import { copyToClipboard } from "../../utils";
import { Component } from "../..";
import * as Sharers from "./urls";
export class Sharer extends Component {
    constructor() {
        super(...arguments);
        this.clickHandler = this.action.bind(this);
    }
    static getUrl(data) {
        let sharer = Sharers[data.type];
        if (sharer) {
            return sharer(data);
        }
    }
    init() {
        this.$element.addEventListener("click", this.clickHandler);
    }
    destroy() {
        this.$element.removeEventListener("click", this.clickHandler);
    }
    action() {
        if (this.$options.type === "copy") {
            copyToClipboard(this.$options.url);
            this.handleCopy();
        }
        else {
            let ctor = this.constructor;
            let url = ctor.getUrl(this.$options);
            if (url) {
                window.open(url, "_blank", `width=${this.$options.width},height=${this.$options.height}`);
            }
        }
    }
    handleCopy() {
        alert("URL copied!");
    }
}
Sharer.defaults = {
    width: 600,
    height: 400,
    url: window.location.href,
    text: document.title,
};
export default Sharer;
