import { Component } from "../..";
interface ToggleOptions {
    target: Element;
    on?: keyof GlobalEventHandlersEventMap;
    off?: keyof GlobalEventHandlersEventMap;
    class?: string;
}
export declare class Toggle extends Component<Element, ToggleOptions> {
    static defaults: Partial<ToggleOptions>;
    onHandler: () => void;
    offHandler: () => void;
    init(): void;
    /**
     * @param value `true` adds, `false` removes, `undefined` toggles the class
     * @returns `true` when the class was added, `false` when removed
     */
    toggle(value?: boolean): boolean;
    activate(): void;
    deactivate(): void;
    get isActive(): boolean;
    destroy(): void;
}
export default Toggle;
