export interface ComponentConstructor<E extends Element = Element, O extends object = object> {
    new (element: E, options?: O): Component<E, O>;
    readonly components?: {
        [key: string]: ComponentConstructor;
    };
    defaults?: Partial<O>;
    $name(ctor: ComponentConstructor): string;
}
export declare class Component<E extends Element = Element, O extends object = object> {
    ["constructor"]: ComponentConstructor<E, O>;
    private _isInit;
    private _isDestroyed;
    $name: string;
    $element: E;
    $options: O;
    $parent: Component;
    $children: Component[];
    static $name(this: ComponentConstructor, ctor: ComponentConstructor): string;
    constructor(element: E, options?: Partial<O>);
    $init(): void;
    private _ref;
    $addChild(component: Component): void;
    $removeChild(component: Component): void;
    $destroy(): void;
    create(): void;
    init(): void;
    destroy(): void;
}
