import { Emitter } from "../../utils/emitter";
class Ticker extends Emitter {
    constructor() {
        super(...arguments);
        this.isActive = false;
        this.handler = this.run.bind(this);
    }
    schedule() {
        this.req = window.requestAnimationFrame(this.handler);
    }
    run() {
        let now = Date.now();
        let delta = now - this.stamp;
        this.emit("tick", delta);
        if (this.isActive) {
            this.stamp = now;
            this.schedule();
        }
    }
    start() {
        this.isActive = true;
        this.stamp = Date.now();
        this.schedule();
    }
    stop() {
        window.cancelAnimationFrame(this.req);
        this.isActive = false;
    }
    checkListeners() {
        if (this.list("tick").length > 0) {
            if (!this.isActive)
                this.start();
        }
        else if (this.isActive) {
            this.stop();
        }
    }
    on(...args) {
        super.on(...args);
        this.checkListeners();
    }
    off(...args) {
        super.off(...args);
        this.checkListeners();
    }
}
export let ticker = new Ticker();
