import { ComponentConstructor } from "../component";
import * as getters from "./getters";
interface WatcherSettings {
    element?: HTMLElement;
    prefix?: string;
    components: {
        [key: string]: ComponentConstructor;
    };
    getters?: {
        [key: string]: getters.Getter;
    };
}
export declare class Watcher {
    private instances;
    private observer?;
    options: WatcherSettings;
    constructor(settings: WatcherSettings);
    private runCreate;
    private runDestroy;
    private handleMutations;
    private parseOptions;
    run(): void;
    observe(): void;
    get<T extends ComponentConstructor>(element: Element, constructor: T): InstanceType<T>;
    destroy(): void;
}
export default Watcher;
