/**
 * Returns the first parent element that matches the predicate.
 */
export declare function findAncestor(element: Element, predicate: (element: Element) => boolean): Element;
/**
 * Returns the first element in the parent tree that has an `<a>` tag, or the
 * input element itself.
 */
export declare function findAnchor(element: Element): HTMLAnchorElement;
/**
 * Returns the page offset of an element according to the sum of its ancestors'
 * offsets.
 */
export declare function offsetGlobal(element: HTMLElement, reference?: any): {
    top: number;
    left: number;
};
/**
 * Calls getBoundingClientRect when the input is an Element and returns it. If
 * the input is Window, an object with a ClientRect shape is returned instead.
 */
export declare function getClientRect(input: Window | Element): DOMRect;
/**
 * Uses the Selection API to put a string in the user's clipboard.
 */
export declare function copyToClipboard(input: string): void;
/**
 * Injects a `<script>` tag in the `<head>` and returns a Promise.
 */
export declare function injectScript(src: string, async?: boolean): Promise<Event>;
