declare type Listener = (...args: any) => void;
declare type List<T> = {
    [K in keyof T]: Listener[];
};
interface Events {
    [key: string]: Listener;
}
export declare class Emitter<T extends Events> {
    listeners: List<T>;
    list(name: keyof T): List<T>[keyof T];
    on<K extends keyof T>(name: K, callback: T[K]): void;
    emit<K extends keyof T>(name: K, ...args: Parameters<T[K]>): void;
    off<K extends keyof T>(name: K, callback: T[K]): void;
}
export {};
