export class Emitter {
    constructor() {
        this.listeners = {};
    }
    list(name) {
        return this.listeners[name] || (this.listeners[name] = []);
    }
    on(name, callback) {
        let l = this.list(name);
        if (l.indexOf(callback) < 0)
            l.push(callback);
    }
    emit(name, ...args) {
        this.list(name).forEach((listener) => {
            try {
                listener(...args);
            }
            catch (e) {
                console.error(e);
            }
        });
    }
    off(name, callback) {
        let l = this.list(name);
        let i = l.indexOf(callback);
        if (i >= 0)
            l.splice(i, 1);
    }
}
