/**
 * Restricts a value to a specified minimum and maximum.
 */
export declare function clamp(number: number, min: number, max: number): number;
export declare class Point {
    x: number;
    y: number;
    static average(...points: Point[]): Point;
    constructor(x?: number, y?: number);
    clone(): Point;
    set(a: number, b?: number): this;
    setPoint(p: Point): this;
    add(a: number, b?: number): this;
    addPoint(p: Point): this;
    addVector(v: Vector): this;
    sub(a: number, b?: number): this;
    subPoint(p: Point): this;
    mul(a: number, b?: number): this;
    mulPoint(p: Point): this;
    dist(p?: Point): number;
    to(input: Point): Vector;
}
export declare class Vector {
    magnitude: number;
    direction: number;
    constructor(p1?: Point, p2?: Point);
    copy(): Vector;
    set(p1: Point, p2?: Point): void;
    add(vector: Vector): void;
}
